/*
	Brick'n'Ball
	Code & Images: Piero Cioni for Red Omega Studio p.s.c.r.l.

	This Widget is a simple game.
	
	Visit our website at: <http://www.redomegastudio.com>

	(c) 2003 - 2004 Red Omega Studio p.s.c.r.l.
*/

var over = 0;
var level = 0;
var score = 0;
var hiScore = preferences.hiScorePref.value;
var gamePaused = 1;
var gameStopped = 1;
var gameWaiting = 1;
var gamePiccolo = 0;
var limit = 1000;
var palle = 3;
var total = 0;
var paddleLenght = 20;
var tempx;
var tr;
var tc;
var ballx;
var bally;
var ballDx;
var ballDy;
var rebounds = 0;
var angle;
var delta;
var falling = 0;
var basey = 40;
var basex = 18;
var brd = new Array();
var brp = new Array();
var brs = new Array();
var bri = new Array();
var cont = 1;
var rx;
var ry;
var freezes = 0;
var kGROW = 11;
var kSHRINK = 12;
var kFREEZE = 13;
var kCOLUMN = 14;
var kBONUS = 15;
var kPLUS = 16;
var kMINUS = 17;
var kRANDOM = 18;
var kHARD = 19;
var kFALSERED = 20;

for(var j = 0;j<7;j++)
{
	bri[j] = new Array();
	brd[j] = new Array();
	brp[j] = new Array();
	brs[j] = new Array();
	for(var i = 0;i<10;i++)
	{
		bri[j][i] = new Image();
		bri[j][i].opacity = 255;
		bri[j][i].hOffset = basex + (i*20);
		bri[j][i].vOffset = basey + (j*16);
		bri[j][i].src = "Resources/Vuoto.png";
		bri[j][i].zOrder = 100 + (j*10) + i;
		brd[j][i] = 0;
		brs[j][i] = 0;
		brp[j][i] = 0;
	}
}

function updateLevel()
{
	levelTextShadow.data = level;
	levelText.data = level;
}

function updateHiScore()
{
	hiScoreTextShadow.data = hiScore;
	hiScoreText.data = hiScore;
}

function updateBricksLeft()
{
	leftTextShadow.data = total;
	leftText.data = total;
}

function updateScore(s)
{
	score += s;
	if(score < 0)
	{
		score = 0;
	}
	scoreTextShadow.data = score;
	scoreText.data = score;
}

function fall()
{
	if(basey < 121)
	{
		for(var j = 0;j<7;j++)
		{
			for(var i = 0;i<10;i++)
			{
				bri[j][i].vOffset += falling;
			}
		}
		basey++;
	}
}

function resetFall()
{
	basey = 40;
	for(var j = 0;j<7;j++)
	{
		for(var i = 0;i<10;i++)
		{
			bri[j][i].vOffset = basey + (j*16);
		}
	}
}

function shrink()
{
	if(paddleLenght > 20)
	{
		paddleLenght -= 10;
		paddle.src = "Resources/Paddle" + (Math.floor(paddleLenght / 10) - 2) + ".png"; 
	}
}

function grow()
{
	if(paddleLenght < 50)
	{
		paddleLenght += 10;
		paddle.src = "Resources/Paddle" + (Math.floor(paddleLenght / 10) - 2) + ".png";
		tempx = system.event.hOffset;
		if(tempx < 20) tempx = 20;
		if((tempx + paddleLenght) > 220) tempx = (220 - paddleLenght);
	}
}

function degrade(r,c)
{
	if(brd[r][c] == kFALSERED)
	{
		brd[r][c] = 4;
		bri[r][c].src = "Resources/Arancione.png";
		brs[r][c] = 1;
		choPlay("Resources/2000.au");
	}
	else if(brd[r][c] == 4)
	{
		brd[r][c] = 2;
		bri[r][c].src = "Resources/Giallo.png";
		brs[r][c] = 0;
		choPlay("Resources/2000.au");
	}
}

function newBall()
{
	switch(palle)
	{
		case 2:
			palla3.opacity = 255;
			palle++;
			break;
		case 1:
			palla2.opacity = 255;
			palle++;
			break;
		case 0:
			palla1.opacity = 255;
			palle++;
			break;
	}
}

function totalBall(c)
{
	var i;
	for(i = 0; i < 7; i++)
	{
		removeBrick(i,c);
	}
}

function freeze()
{
	freezes = 5;
}

function startGame()
{
	level = parseInt(preferences.start.value);
	score = 0;
	scoreTextShadow.data = score;
	scoreText.data = score;
	hiScore = preferences.hiScorePref.value;
	updateHiScore(hiScore);
	scoreTextShadow.opacity = 255;
	scoreText.opacity = 255;
	leftTextShadow.opacity = 255;
	leftText.opacity = 255;
	hiScoreTextShadow.opacity = 255;
	hiScoreText.opacity = 255;
	levelTextShadow.opacity = 255;
	levelText.opacity = 255;
	palle = 3;
	rebounds = 0;
	palla1.opacity = 255;
	palla2.opacity = 255;
	palla3.opacity = 255;
	paddle.src = "Resources/Paddle2.png";
	paddle.opacity = 255;
	paddle.hOffset = 105;
	paddleLenght = 40;
	gamePaused = 0;
	gameStopped = 0;
	gameWaiting = 1;
	gamePiccolo = 0;
	ballx = 111;
	bally = 252;
	ballDx = -4;
	ballDy = -4;
	basey = 40;
	falling = 0;
	freezes = 0;
	ball.hOffset = ballx;
	ball.vOffset = bally;
	ball.opacity = 255;
	prepareLevel(level);
	updateBricksLeft();
	updateLevel();
	showStatic("HIT L TO LAUNCH")
	//deShowStatic();
}

function prepareLevel(p)
{
	resetFall();
	ballDy = -4;
	paddleLenght = 40;
	paddle.src = "Resources/Paddle2.png";
	var i,j;
	switch(p)
	{
		case 1:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 1;
				brd[1][i] = 2;
				brd[2][i] = 3;
				brd[3][i] = 2;
				brd[4][i] = 3;
				brd[5][i] = 2;
				brd[6][i] = 1;
			}
			brd[2][0] = kGROW;
			brd[2][9] = kGROW;
			brd[4][0] = kGROW;
			brd[4][9] = kGROW;
			brd[0][0] = kBONUS;
			brd[0][9] = kBONUS;
			total = 70;
			falling = 0;
			break;
		case 2:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 3;
				brd[1][i] = 3;
				brd[2][i] = 2;
				brd[3][i] = 2;
				brd[4][i] = 1;
				brd[5][i] = 1;
				brd[6][i] = 1;
			}
			brd[4][0] = kGROW;
			brd[4][9] = kGROW;
			brd[2][0] = kSHRINK;
			brd[2][9] = kSHRINK;
			brd[0][0] = kGROW;
			brd[0][9] = kGROW;
			total = 70;
			falling = 1;
			break;
		case 3:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 1;
				brd[1][i] = 1;
				brd[2][i] = 1;
				brd[3][i] = 2;
				brd[4][i] = 2;
				brd[5][i] = kFALSERED;
				brd[6][i] = kFALSERED;
			}
			total = 70;
			falling = 1;
			break;
		case 4:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 3;
				brd[1][i] = 3;
				brd[2][i] = 2;
				brd[3][i] = 2;
				brd[4][i] = 1;
				brd[5][i] = 1;
				brd[6][i] = 1;
			}
			brd[2][0] = kGROW;
			brd[2][9] = kGROW;
			brd[0][0] = kFREEZE;
			brd[0][9] = kFREEZE;
			total = 70;
			falling = 1;
			break;
		case 5:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = kFALSERED;
				brd[1][i] = 2;
				brd[2][i] = kFALSERED;
				brd[3][i] = 1;
				brd[4][i] = kFALSERED;
				brd[5][i] = 2;
				brd[6][i] = kFALSERED;
			}
			brd[3][5] = kBONUS;
			brd[3][4] = kBONUS;
			total = 70;
			falling = 1;
			break;
		case 6:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 1;
				brd[1][i] = 1;
				brd[2][i] = 2;
				brd[3][i] = 2;
				brd[4][i] = 3;
				brd[5][i] = 3;
				brd[6][i] = kFALSERED;
			}
			brd[2][0] = kGROW;
			brd[2][2] = kGROW;
			brd[2][7] = kGROW;
			brd[2][9] = kGROW;
			total = 70;
			falling = 2;
			break;
		case 7:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 2;
				brd[1][i] = 2;
				brd[2][i] = 2;
				brd[3][i] = 2;
				brd[4][i] = 2;
				brd[5][i] = 2;
				brd[6][i] = 2;
			}
			brd[0][3] = 3;
			brd[0][4] = 3;
			brd[0][5] = 3;
			brd[0][6] = 3;
			brd[1][2] = 3;
			brd[1][3] = 3;
			brd[1][6] = 3;
			brd[1][7] = 3;
			brd[2][1] = 3;
			brd[2][2] = 3;
			brd[2][7] = 3;
			brd[2][8] = 3;
			brd[3][1] = 3;
			brd[3][2] = 3;
			brd[3][7] = 3;
			brd[3][8] = 3;
			brd[4][2] = 3;
			brd[4][3] = 3;
			brd[4][6] = 3;
			brd[4][7] = 3;
			brd[5][3] = 3;
			brd[5][6] = 3;
			brd[6][1] = 3;
			brd[6][2] = 3;
			brd[6][3] = 3;
			brd[6][6] = 3;
			brd[6][7] = 3;
			brd[6][8] = 3;
			total = 70;
			falling = 1;
			break;
		case 8:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 5;
				brd[1][i] = 5;
				brd[2][i] = 5;
				brd[3][i] = kFALSERED;
				brd[4][i] = 5;
				brd[5][i] = 5;
				brd[6][i] = 5;
			}
			total = 70;
			falling = 1;
			break;
		case 9:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 5;
				brd[1][i] = 6;
				brd[2][i] = 7;
				brd[3][i] = 5;
				brd[4][i] = 7;
				brd[5][i] = 6;
				brd[6][i] = 5;
			}
			brd[3][0] = kMINUS;
			brd[3][2] = kMINUS;
			brd[3][7] = kMINUS;
			brd[3][9] = kMINUS;
			total = 70;
			falling = 1;
			break;
		case 10:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 5;
				brd[1][i] = 5;
				brd[2][i] = 5;
				brd[3][i] = 6;
				brd[4][i] = 6;
				brd[5][i] = 7;
				brd[6][i] = 7;
			}
			brd[0][0] = kBONUS;
			brd[0][9] = kBONUS;
			total = 70;
			falling = 1;
			break;
		case 11:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 5;
				brd[1][i] = 5;
				brd[2][i] = 5;
				brd[3][i] = 5;
				brd[4][i] = 5;
				brd[5][i] = 5;
				brd[6][i] = 5;
			}
			brd[0][3] = kFALSERED;
			brd[0][4] = kFALSERED;
			brd[0][5] = kFALSERED;
			brd[0][6] = kFALSERED;
			brd[1][2] = 3;
			brd[1][3] = 3;
			brd[1][6] = 3;
			brd[1][7] = 3;
			brd[2][1] = 3;
			brd[2][2] = 3;
			brd[2][7] = 3;
			brd[2][8] = 3;
			brd[3][1] = 3;
			brd[3][2] = 3;
			brd[3][7] = 3;
			brd[3][8] = 3;
			brd[4][2] = 3;
			brd[4][3] = 3;
			brd[4][6] = 3;
			brd[4][7] = 3;
			brd[5][3] = 3;
			brd[5][6] = 3;
			brd[6][1] = kFALSERED;
			brd[6][2] = kFALSERED;
			brd[6][3] = kFALSERED;
			brd[6][6] = kFALSERED;
			brd[6][7] = kFALSERED;
			brd[6][8] = kFALSERED;
			total = 70;
			falling = 0;
			break;
		case 12:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 7;
				brd[1][i] = 7;
				brd[2][i] = 7;
				brd[3][i] = 7;
				brd[4][i] = 7;
				brd[5][i] = 7;
				brd[6][i] = 7;
			}
			brd[2][2] = kFALSERED;
			brd[2][3] = kFALSERED;
			brd[2][4] = kFALSERED;
			brd[2][5] = kFALSERED;
			brd[2][6] = kFALSERED;
			brd[2][7] = kFALSERED;
			brd[3][2] = kFALSERED;
			brd[3][3] = kBONUS;
			brd[3][4] = kBONUS;
			brd[3][5] = kBONUS;
			brd[3][6] = kBONUS;
			brd[3][7] = kFALSERED;
			brd[4][2] = kFALSERED;
			brd[4][3] = kFALSERED;
			brd[4][4] = kFALSERED;
			brd[4][5] = kFALSERED;
			brd[4][6] = kFALSERED;
			brd[4][7] = kFALSERED;
			total = 70;
			falling = 1;
			break;
		case 13:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 10;
				brd[1][i] = 10;
				brd[2][i] = 10;
				brd[3][i] = 8;
				brd[4][i] = 8;
				brd[5][i] = 9;
				brd[6][i] = 9;
			}
			brd[1][0] = kBONUS;
			brd[1][1] = kMINUS;
			brd[1][2] = kMINUS;
			brd[1][3] = kPLUS;
			brd[1][6] = kPLUS;
			brd[1][7] = kMINUS;
			brd[1][8] = kMINUS;
			brd[1][9] = kBONUS;
			total = 70;
			falling = 1;
			break;
		case 14:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 9;
				brd[1][i] = 8;
				brd[2][i] = 10;
				brd[3][i] = 10;
				brd[4][i] = 10;
				brd[5][i] = 8;
				brd[6][i] = 9;
			}
			brd[3][1] = kFREEZE;
			brd[3][3] = kGROW;
			brd[3][6] = kGROW;
			brd[3][8] = kFREEZE;
			total = 70;
			falling = 1;
			break;
		case 15:
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = 10;
				brd[1][i] = 5;
				brd[2][i] = kMINUS;
				brd[3][i] = kGROW;
				brd[4][i] = kPLUS;
				brd[5][i] = 5;
				brd[6][i] = 10;
			}
			brd[3][1] = kFREEZE;
			brd[3][3] = kBONUS;
			brd[3][6] = kBONUS;
			brd[3][8] = kFREEZE;
			total = 70;
			falling = 1;
			break;
		default:	// livello random
			for(i = 0;i < 10;i++)
			{
				brd[0][i] = random(1,10);
				brd[1][i] = random(1,10);
				brd[2][i] = random(1,10);
				brd[3][i] = random(1,10);
				brd[4][i] = random(1,10);
				brd[5][i] = random(1,10);
				brd[6][i] = random(1,10);
			}
			total = 70;
			falling = 0;
			break;
	}
	for(j = 0;j<7;j++)
	{
		for(i = 0;i<10;i++)
		{
			switch(brd[j][i])
			{
				case 0:
					bri[j][i].src = "Resources/Vuoto.png";
					brs[j][i] = 0;
					brp[j][i] = 0;
					break;
				case 1:
					bri[j][i].src = "Resources/Verde.png";
					brs[j][i] = 0;
					brp[j][i] = 10;
					break;
				case 2:
					bri[j][i].src = "Resources/Giallo.png";
					brs[j][i] = 0;
					brp[j][i] = 10;
					break;
				case 3:
					bri[j][i].src = "Resources/Rosso.png";
					brs[j][i] = 0;
					brp[j][i] = 10;
					break;
				case 4:
					bri[j][i].src = "Resources/Arancione.png";
					brs[j][i] = 0;
					brp[j][i] = 20;
					break;
				case 5:
					bri[j][i].src = "Resources/Grigio.png";
					brs[j][i] = 0;
					brp[j][i] = 20;
					break;
				case 6:
					bri[j][i].src = "Resources/Azzurro.png";
					brs[j][i] = 0;
					brp[j][i] = 20;
					break;
				case 7:
					bri[j][i].src = "Resources/Blu.png";
					brs[j][i] = 0;
					brp[j][i] = 20;
					break;
				case 8:
					bri[j][i].src = "Resources/Lilla.png";
					brs[j][i] = 0;
					brp[j][i] = 30;
					break;
				case 9:
					bri[j][i].src = "Resources/Viola.png";
					brs[j][i] = 0;
					brp[j][i] = 30;
					break;
				case 10:
					bri[j][i].src = "Resources/Paddle0.png";
					brs[j][i] = 0;
					brp[j][i] = 20;
					break;
				case kGROW:
					bri[j][i].src = "Resources/NeroG.png";
					brs[j][i] = 2;
					brp[j][i] = 50;
					break;
				case kSHRINK:
					bri[j][i].src = "Resources/NeroS.png";
					brs[j][i] = 3;
					brp[j][i] = 100;
					break;
				case kFREEZE:
					bri[j][i].src = "Resources/NeroF.png";
					brs[j][i] = 8;
					brp[j][i] = 50;
					break;
				case kCOLUMN:
					bri[j][i].src = "Resources/NeroC.png";
					brs[j][i] = 7;
					brp[j][i] = 50;
					break;
				case kBONUS:
					bri[j][i].src = "Resources/NeroB.png";
					brs[j][i] = 6;
					brp[j][i] = 50;
					break;
				case kPLUS:
					bri[j][i].src = "Resources/NeroP.png";
					brs[j][i] = 4;
					brp[j][i] = 100;
					break;
				case kMINUS:
					bri[j][i].src = "Resources/NeroM.png";
					brs[j][i] = 5;
					brp[j][i] = 50;
					break;
				case kRANDOM:
					bri[j][i].src = "Resources/NeroX.png";
					brs[j][i] = random(2,9);
					brp[j][i] = random(1,4) * 50;
					break;
				case kHARD:
					bri[j][i].src = "Resources/Paddle0.png";
					brs[j][i] = 9;
					brp[j][i] = 0;
					total--;
					break;
				case kFALSERED:
					bri[j][i].src = "Resources/Rosso.png";
					brs[j][i] = 1;
					brp[j][i] = 30;
					break;
			}
		}
	}
}

function resetHiScore()
{
	var a = alert("Do you really want to reset the high score?","Ok","Cancel");
	if(a == 1)
	{
		hiScore = 0;
		updateHiScore();
		preferences.hiScorePref.value = 0;
		savePreferences();
	}
}

function pauseGame()
{
  gamePaused = 1;
  showStatic("PAUSED");
}

function resumeGame()
{
	gamePaused = 0;
	deShowStatic();
}

function removeBrick(r,c)
{
	brd[r][c] = 0;
	bri[r][c].src = "Resources/Vuoto.png";
	brs[r][c] = 0;
	total--;
	choPlay("Resources/2000.au");
}

function checkSideWalls()
{
	if(newx <= basex)
	{
		rectd = basex;
		ballDx = -ballDx;
		choPlay("Resources/1000.au");
		cont = 0;
	}
	else if(newx >= (basex+200))
	{
		rects = (basex+200);
		ballDx = -ballDx;
		choPlay("Resources/1000.au");
		cont = 0;
	}
	else cont = 1;
}

function checkTopWall()
{
	if(newy <= 20)
	{
		rectb = 20;
		ballDy = -ballDy;
		choPlay("Resources/1000.au");
		cont = 0;
	}
	else cont = 1;
}

function checkBottomWall()
{
	if(newy >= 268) // il fondo e' a 276 ma oltre 268 il paddle e' gia' stato superato
	{
		choPlay("Resources/2000.au");
		if(palle == 0)
		{
			over = 1;
		}
		else
		{
			switch(palle)
			{
				case 3:
					palla3.opacity = 0;
					break;
				case 2:
					palla2.opacity = 0;
					break;
				case 1:
					palla1.opacity = 0;
					break;
			}
			palle--;
			gameWaiting = 1;
			setGameWaiting();
		}
		cont = 0;
	}
	else cont = 1;
}

function setGameWaiting()
{
	ballx = paddle.hOffset + 3 + Math.floor(paddleLenght / 2);
	bally = 258;
	ballDx = 4;
	ballDy = -4;
	rebounds = 0;
	showStatic("HIT L TO LAUNCH");
}

function checkPaddle()
{
	if((newy >= 258) && (newx >= paddle.hOffset) && (newx <= (paddle.hOffset + paddleLenght)))
	{
		rx = ballDx;
		angle = ballx - paddle.hOffset;
		if(angle <= 2) ballDx = -8;
		else if(angle <= 4) ballDx = -6;
		else if(angle <= (paddleLenght - 4)) ballDx = ballDx;  // Arg!!
		else if(angle <= (paddleLenght - 2)) ballDx = 6;
		else ballDx = 8;
		ballDy = -ballDy;
		rebounds++;
		if(rebounds > 7)
		{
			rebounds = 0;
			if(ballDy < 0) ballDy--;
			else ballDy++;
		}
		if(freezes > 0)
		{
			freezes--;
			gameWaiting = 1;
			setGameWaiting();
		}
		if(falling > 0) fall();
		choPlay("Resources/500.au");
		cont = 0;
	}
	else cont = 1;
}

function checkBricks()
{
	if((newy >= basey) && (newy <= (basey + 111)))
	{
		// cerco di calcolare in quale mattone si trova dentro
		tr = Math.floor((newy - basey) / 16);
		tc = Math.floor((newx - 20) / 20);
		if(brd[tr][tc] > 0)
		{
			//print("HIT: tr="+tr+" tc="+tc);
			switch(brs[tr][tc])
			{
				case 0:
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 1:	// degradazione
					degrade(tr,tc);
					break;
				case 2:	// grow del paddle
					grow();
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 3:	// shrink del paddle
					shrink();
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 4:	// accellera
					if(ballDy < 0) ballDy -= 1;
					else ballDy += 1;
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 5:	// rallenta
					if(ballDy < 0)
					{
						ballDy += 1;
						if(ballDy == 0) ballDy = -1;
					}
					else
					{
						ballDy -= 1;
						if(ballDy == 0) ballDy = 1;
					}
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 6:	// pallina bonus
					newBall();
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 7:	// pallina totale
					totalBall(tc);
					break;
				case 8: // colla
					freeze();
					removeBrick(tr,tc);
					updateScore(brp[tr][tc] + (level * 5));
					break;
				case 9:	// mattone indistruttibile
					break;
			}
			// calcolo il rimbalzo - nuovo sistema
			recta = bri[tr][tc].vOffset;
			rectb = recta + 16;
			rects = bri[tr][tc].hOffset;
			rectd = rects + 20;
			doBounds();
			updateBricksLeft();
			if(total < 1) endLevel();
		}
	}
}
/*
function doBounds()
{
	if((ballDx > 0)&&(ballDy > 0)) // sto andando in basso a dx
	{
		if(bally <= recta) rimbalzo1(); // sopra
		else if(ballx <= rects) rimbalzo2(); // a sinistra
		else if((recta - bally) >= (rects - ballx)) rimbalzo1(); // nell angolo ma piu sopra
		else rimbalzo2(); // nell angolo ma piu a sinistra
	}
	else if((ballDx > 0)&&(ballDy < 0)) // sto andando in alto a dx
	{
		if(bally >= rectb) rimbalzo3(); // sotto
		else if(ballx <= rects) rimbalzo2(); // a sinistra
		else if((bally - rectb) >= (rects - ballx)) rimbalzo3(); // nell angolo ma piu sotto
		else rimbalzo2(); // nell angolo ma piu a sinistra
	}
	else if((ballDx < 0)&&(ballDy < 0)) // sto andando in alto a sx
	{
		if(bally >= rectb) rimbalzo3(); // sotto
		else if(ballx >= rectd) rimbalzo4(); // a destra
		else if((bally - rectb) >= (ballx - rectd)) rimbalzo3(); // nell angolo ma piu sotto
		else rimbalzo4(); // nell angolo ma piu a destra
	}
	else // sto andando in basso a sx
	{
		if(bally <= recta) rimbalzo1(); // sopra
		else if(ballx >= rectd) rimbalzo4(); // a destra
		else if((recta - bally) >= (ballx - rectd)) rimbalzo1(); // nell angolo ma piu sopra
		else rimbalzo4(); // nell angolo ma piu a destra
	}
}

function rimbalzo1()
{
	rx = ballDx;
	ry = ballDy - ((newy - recta) * 2);
	//print("R1::  rx="+rx+"  ry="+ry);
	ballDy = -ballDy;
}

function rimbalzo2()
{
	ry = ballDy;
	rx = ballDx - ((newx - rects) * 2);
	//print("R2::  rx="+rx+"  ry="+ry);
	ballDx = -ballDx;
}

function rimbalzo3()
{
	rx = ballDx;
	ry = ballDy + ((rectb - newy) * 2);
	//print("R3::  rx="+rx+"  ry="+ry);
	ballDy = -ballDy;
}

function rimbalzo4()
{
	ry = ballDy;
	rx = ballDx + ((rectd - newx) * 2);
	//print("R4::  rx="+rx+"  ry="+ry);
	ballDx = -ballDx;
}
*/

function doBounds()
{
	if((ballDx > 0)&&(ballDy > 0)) // sto andando in basso a dx
	{
		if(bally <= recta) ballDy = -ballDy; // sopra
		else if(ballx <= rects) ballDx = -ballDx; // a sinistra
		else if((recta - bally) >= (rects - ballx)) ballDy = -ballDy; // nell angolo ma piu sopra
		else ballDx = -ballDx; // nell angolo ma piu a sinistra
	}
	else if((ballDx > 0)&&(ballDy < 0)) // sto andando in alto a dx
	{
		if(bally >= rectb) ballDy = -ballDy; // sotto
		else if(ballx <= rects) ballDx = -ballDx; // a sinistra
		else if((bally - rectb) >= (rects - ballx)) ballDy = -ballDy; // nell angolo ma piu sotto
		else ballDx = -ballDx; // nell angolo ma piu a sinistra
	}
	else if((ballDx < 0)&&(ballDy < 0)) // sto andando in alto a sx
	{
		if(bally >= rectb) ballDy = -ballDy; // sotto
		else if(ballx >= rectd) ballDx = -ballDx; // a destra
		else if((bally - rectb) >= (ballx - rectd)) ballDy = -ballDy; // nell angolo ma piu sotto
		else ballDx = -ballDx; // nell angolo ma piu a destra
	}
	else // sto andando in basso a sx
	{
		if(bally <= recta) ballDy = -ballDy; // sopra
		else if(ballx >= rectd) ballDx = -ballDx; // a destra
		else if((recta - bally) >= (ballx - rectd)) ballDy = -ballDy; // nell angolo ma piu sopra
		else ballDx = -ballDx; // nell angolo ma piu a destra
	}
}

function onTimer()
{
	if(gameStopped == 0)
	{
		if(gamePaused == 0)
		{
			if(gamePiccolo == 0)
			{
				if(gameWaiting == 1)
				{
					tempx = system.event.hOffset;
					if(tempx < basex) tempx = basex;
					if((tempx + paddleLenght) > (basex+200)) tempx = ((basex + 200) - paddleLenght);
					ballx = tempx + Math.floor(paddleLenght / 2);
					ball.hOffset = ballx - 3;
					ball.vOffset = bally - 3;
					paddle.hOffset = tempx;
					updateNow();
				}
				else
				{
					over = 0;
					cont = 1;
					tempx = system.event.hOffset;
					if(tempx < basex) tempx = basex;
					if((tempx + paddleLenght) > (basex+200)) tempx = ((basex + 200) - paddleLenght);
					newx = ballx + ballDx;
					newy = bally + ballDy;
					checkSideWalls();
					if(cont > 0) checkTopWall();
					if(cont > 0) checkBottomWall();
					if(cont > 0) checkPaddle();
					if(cont > 0) checkBricks();
					if(over > 0) gameOver();
					ballx += ballDx;
					bally += ballDy;
					ball.hOffset = ballx - 3;
					ball.vOffset = bally - 3;
					paddle.hOffset = tempx;
					updateNow();
				}
			}
		}
	}
}

function choPlay(s)
{
	if(preferences.sound.value == 1) play(s);
}

function switchPiccolo()
{
	if(gamePiccolo == 0)
	{
		gamePaused = 1;
		gamePiccolo = 1;
		mappa.opacity = 0;
		levelText.opacity = 0;
		levelTextShadow.opacity = 0;
		levelLabel.opacity = 0;
		levelLabelShadow.opacity = 0;
		leftText.opacity = 0;
		leftTextShadow.opacity = 0;
		leftLabel.opacity = 0;
		leftLabelShadow.opacity = 0;
		scoreText.opacity = 0;
		scoreTextShadow.opacity = 0;
		scoreLabel.opacity = 0;
		scoreLabelShadow.opacity = 0;
		hiScoreText.opacity = 0;
		hiScoreTextShadow.opacity = 0;
		hiScoreLabel.opacity = 0;
		hiScoreLabelShadow.opacity = 0;
		ballsLabel.opacity = 0;
		ballsLabelShadow.opacity = 0;
		gameOverText.opacity = 0;
		gameOverTextShadow.opacity = 0;
		for(i = 0;i < 10;i++)
		{
			bri[0][i].opacity = 0;
			bri[1][i].opacity = 0;
			bri[2][i].opacity = 0;
			bri[3][i].opacity = 0;
			bri[4][i].opacity = 0;
			bri[5][i].opacity = 0;
			bri[6][i].opacity = 0;
		}
		palla1.opacity = 0;
		palla2.opacity = 0;
		palla3.opacity = 0;
		ball.opacity = 0;
		paddle.opacity = 0;
	}
	else
	{
		gamePiccolo = 0;
		mappa.opacity = 255;
		levelText.opacity = 255;
		levelTextShadow.opacity = 255;
		levelLabel.opacity = 255;
		levelLabelShadow.opacity = 255;
		leftText.opacity = 255;
		leftTextShadow.opacity = 255;
		leftLabel.opacity = 255;
		leftLabelShadow.opacity = 255;
		scoreText.opacity = 255;
		scoreTextShadow.opacity = 255;
		scoreLabel.opacity = 255;
		scoreLabelShadow.opacity = 255;
		hiScoreText.opacity = 255;
		hiScoreTextShadow.opacity = 255;
		hiScoreLabel.opacity = 255;
		hiScoreLabelShadow.opacity = 255;
		ballsLabel.opacity = 255;
		ballsLabelShadow.opacity = 255;
		gameOverText.opacity = 255;
		gameOverTextShadow.opacity = 255;
		for(i = 0;i < 10;i++)
		{
			bri[0][i].opacity = 255;
			bri[1][i].opacity = 255;
			bri[2][i].opacity = 255;
			bri[3][i].opacity = 255;
			bri[4][i].opacity = 255;
			bri[5][i].opacity = 255;
			bri[6][i].opacity = 255;
		}
		switch(palle)
		{
			case 3:
				palla3.opacity = 255;
				palla2.opacity = 255;
				palla1.opacity = 255;
				break;
			case 2:
				palla2.opacity = 255;
				palla1.opacity = 255;
				break;
			case 1:
				palla1.opacity = 255;
				break;
		}
		if(gameStopped == 0)
		{
			ball.opacity = 255;
			paddle.opacity = 255;
		}
	}
}

function onKeyDown()
{
	var keyCode = String.fromCharCode(system.event.keyString);

	if(gameStopped == 1)
	{
		if(keyCode.indexOf("s") != -1) startGame();
		if(keyCode.indexOf("S") != -1) startGame();
		if(keyCode.indexOf("r") != -1) resetHiScore();
		if(keyCode.indexOf("R") != -1) resetHiScore();
		if(keyCode.indexOf("b") != -1) switchPiccolo();
		if(keyCode.indexOf("B") != -1) switchPiccolo();
	}
	else
	{
	  if(gamePaused == 1)
	  {
	    if(keyCode.indexOf("p") != -1) resumeGame();
	    if(keyCode.indexOf("P") != -1) resumeGame();
		if(keyCode.indexOf("b") != -1) switchPiccolo();
		if(keyCode.indexOf("B") != -1) switchPiccolo();
	  }
	  else
	  {
	    if(keyCode.indexOf("p") != -1) pauseGame();
	    if(keyCode.indexOf("P") != -1) pauseGame();
	    if(keyCode.indexOf("l") != -1) launchBall();
	    if(keyCode.indexOf("L") != -1) launchBall();
		if(keyCode.indexOf("b") != -1) switchPiccolo();
		if(keyCode.indexOf("B") != -1) switchPiccolo();
	  }
	}
	return false;
}

function onLoseFocus()
{
	gamePaused = 1;
	gameOverTextShadow.data = "PAUSED";
	gameOverText.data = "PAUSED";
}

function launchBall()
{
	if(gameWaiting == 1)
	{
		gameWaiting = 0;
		deShowStatic();
	}
}

function showWord(s)
{
	var i;
	gameOverTextShadow.data = s;
	gameOverText.data = s;
	for(i = 0; i <= 240; i += 10)
	{
		gameOverTextShadow.opacity = i;
		gameOverText.opacity = i;
		updateNow();
	}
	for(i = 240; i >= 0; i -= 10)
	{
		gameOverTextShadow.opacity = i;
		gameOverText.opacity = i;
		updateNow();
	}
}

function showStatic(s)
{
	gameOverTextShadow.data = s;
	gameOverText.data = s;
	if(gamePiccolo == 0)
	{
		gameOverTextShadow.opacity = 255;
		gameOverText.opacity = 255;
	}
	updateNow();
}

function deShowStatic()
{
	gameOverTextShadow.opacity = 0;
	gameOverText.opacity = 0;
	updateNow();
}

function gameOver()
{
	gameStopped = 1;
	showWord("GAME OVER");
	if(score > hiScore)
	{
		preferences.hiScorePref.value = score;
		hiScore = score;
		savePreferences();
		updateHiScore();
		showWord("HIGH SCORE");
		if(hiScore > 10000)
		{
			if(parseInt(preferences.reg.value) > 0) sendRecord();
		}
	}
	showStatic("HIT S TO PLAY");
	level = preferences.start.value;
}

function endLevel()
{
	level++;
	gameWaiting = 1;
	showWord("LEVEL: " + level);
	setGameWaiting();
	prepareLevel(level);
	updateLevel();
}

function sendRecord()
{
	if(preferences.id.value == 0)
	{
		var ff = new Array();
		ff[0] = new FormField();
		ff[0].name = "ff_nick";
		ff[0].type = "text";
		ff[0].title = "Nickname:";
		ff[0].minLength = 3;
		ff[0].maxLength = 20;
		ff[0].description = "Please enter a nickname from 3 to 20 characters.";		
		var n = form(ff,"Nickname","Ok","Cancel");
		if(!n) return;
		else
		{
			while((n[0].length < 3)||(n[0].length > 21))
			{
				n = form(ff,"Nickname","Ok","Cancel");
				if(!n) return;
			}
			preferences.nick.value = n[0];
			savePreferences();
		}
	}
	var u = new URL();
	var l = "http://www.redomegastudio.com/comune/reg_bb.php?id="+preferences.id.value+"&nn="+preferences.nick.value+"&pp="+hiScore+"&ll="+level; // questo sara quello vero
	var c = u.fetch(l);
	var w = c.split(',');
	if(w[0] != 0)
	{
		alert(w[1]);
	}
	else
	{
		preferences.id.value = w[1];
		var a = alert("Your score has been written on our database!","Ok","Visit the website");
		if(a == 2)
		{
			openURL("http://www.redomegastudio.com/eng/bricknball.php");
		}
	}
}

system.mute = true;
choPlay("Resources/500.au");
choPlay("Resources/1000.au");
choPlay("Resources/2000.au");
main_window.visible = true;
suppressUpdates();
showStatic("HIT S TO PLAY");
focusWidget();
system.mute = false;